#!/usr/bin/env python3
#Modified Sequitur Compression program

import seqaltFindConsecStringLength	#find duplicate occurrences of single characters
import seqaltFindOcc		#find duplicate occurrences of particular strings
print('\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n%\nBegin Seq-Alt data compression Program')
for g in range(0,20):
	print("+-+-+- & ",end="")
print("+-+-+-")
	
infile='apng'
#infile=input('type name of file for compression/encryption: ') #activate this line if you'd like to type in your filename

fr=open(infile,'rb')	#create handle on file for reading
a=fr.read()		#copy file contents to a variable
fr.close()		#close file
if fr.closed:
	print("\nsuccessfully read and then closed source file \'" + infile + "\' of length " + str(len(a)))

#Phase 1 - find if long lists of duplicate character
#findCharList(dataset)
charListSubst=seqaltFindConsecStringLength.findCharList(a)										#call the subroutine
sl=sorted(charListSubst.items())
#print("\n\ncharListSubst: " + sorted(charListSubst.items()) + "\n")
print("\nlargest value dec-encoded ASCII found:" + str(max(charListSubst)))
print("\nASCII value with largest number of consecutive duplicates: " + str(max(charListSubst, key=charListSubst.get)))
print("(dec-encoded-ASCII,[number of times ANY consecutive dupe character encountered , length of largest number of consecutive duplicates])")
print(sorted(charListSubst.items(), key=lambda kv:(kv[1][1], kv[0])))
print("\nsorted by key, ASCII value:")
for i in sl:
	print(chr(i[0]) + " : " + str(i[1][0]) + " , " + str(i[1][1]) ,end="       ")
print("\n\n+------+---- end of dupe character detect ----+------+")

#Phase 2 - find if duplicates of strings of characters.... "sliding window"
#search for a point of large-scale substitutions start-point default parameters
# "Words" within "Blocks" will be chosen, and duplicates searched for in the file
# Either few but very large words, or many smaller words, can be advantageous, so take a product of "wordlength x number words"
# record number of dupes, location of source word, then delta(s) to location(s) of duplicate word(s)

wordLengthDefault = 2		#start off looking for fairly large words

BlockSize=400	#from begin of file TO THIS location, start systematically picking words of wordLength
if BlockSize >= len(a) - wordLengthDefault:
	print("default Block size is " + str(BlockSize) + " but that's longer than the file of length " + str(len(a)) + " so BlockSize will be reduced")
	BlockSize = len(a) - wordLengthDefault - 1

blocks=5
if BlockSize * blocks >= len(a) - wordLengthDefault:
	blocks = 1
	BlockSize = len(a) - wordLengthDefault
	print("for short file, adjusted blocks to 1 & BlockSize = file size - word length")

wordLength=wordLengthDefault
print("\nNow sliding window test\nend of first block where search words may be located " + str(BlockSize))
print("\n\nStarting looking for words of length: " + str(wordLengthDefault))
MatchSummary=[]
summaryFile='seqalt_' + str(infile) + ".txt"
fs = open(summaryFile, 'a')
fs.write("from file \'" + infile + "\' using blocksize " + str(BlockSize) + " and word length: " + str(wordLength) + "\'\n")
fs.close()
for j in range(0,blocks):
	print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ begin sliding window source-data block " + str(j+1) + " ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n")
	## call format: findInFile(dataset,offsetStart,offsetStop,scanWordLength)
	matchData=seqaltFindOcc.findInFile(a,j*BlockSize,(j+1)*BlockSize,wordLength)					#call the subroutine
	## returned data format: MatchData[0,1,2,3]
	##MatchesData - 3 lists, and an int: [PositionOfSourceWord(list),PositionOfDupeWord(list),TheDupeWord(list),HowMuchToIncreaseScanWordLength(int)]
	##the full lists including dupes
	print("\nmatchcount:" + str(len(matchData[0])) + "    for letter words:" + str(wordLength), end=" ")
	print("\n\n\nthe match terms: \n" + str(matchData[2]))
	print("\nthe source terms having matches located at: \n" + str(matchData[0]))
	print("\n" + str(len(matchData[1])) + " matches for search terms found at locations:\n" + str(matchData[1]))

	##the "set" versions (dupes removed):
	#print("\nthe match terms: \n" + str(set(matchData[2])))
	print()
	x=set(matchData[2])
	for k in x:
		print(k, end=' ')
	#print("\nthe terms having matches located at: \n" + str(set(matchData[0])))
	#print("\n\n" + str(len(set(matchData[1]))) + " \nmatches for search terms found at locations:\n" + str(set(matchData[1])))
	print("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ end of sliding window source-data block " + str(j+1) + " ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~")
	MatchSummary.append(matchData[3])
	print("Excess-Match Summary - search words could be this much longer and still find dupe words in file (per block)" + str(MatchSummary))
	fs = open(summaryFile, 'a')
	fs.write(" block \'" + str(j+1) + "\' excess match chars: " + str(MatchSummary[j]) + "\n")
	fs.close()
if fs.closed == 'False':
	fs.close()
	